#ifndef lint
static char sccsid[] = "@(#)tiff_dumpmode.c	1.6 2/19/89";
#endif

/*
 * Copyright (c) 1988 by Sam Leffler.
 * All rights reserved.
 *
 * This file is provided for unrestricted use provided that this
 * legend is included on all tape media and as a part of the
 * software program in whole or part.  Users may copy, modify or
 * distribute this file at will.
 */

/*
 * TIFF Library.
 *
 * "Null" Compression Algorithm Support.
 */
#include "tiffio.h"

static	int DumpModeEncode(), DumpModeDecode();

/*
 * Initialize dump mode.
 */
TIFFInitDumpMode(tif)
	TIFF *tif;
{

	tif->tif_decodestrip = NULL;
	tif->tif_decoderow = DumpModeDecode;
	tif->tif_encoderow = DumpModeEncode;
	tif->tif_encodestrip = NULL;
	tif->tif_setfield = NULL;
	tif->tif_done = NULL;
	return (1);
}

/*
 * Encode a scanline of pixels.
 */
static
DumpModeEncode(tif, pp)
	TIFF *tif;
	u_char *pp;
{

	if (tif->tif_rawcc + tif->tif_scanlinesize > tif->tif_rawdatasize)
		if (!TIFFFlushData(tif))
			return (-1);
	bcopy(pp, tif->tif_rawcp, tif->tif_scanlinesize);
	tif->tif_rawcp += tif->tif_scanlinesize;
	tif->tif_rawcc += tif->tif_scanlinesize;
	return (1);
}

/*
 * Decode a scanline of pixels.
 */
static
DumpModeDecode(tif)
	TIFF *tif;
{

	tif->tif_scanline = tif->tif_rawcp;
	tif->tif_rawcp += tif->tif_scanlinesize;
	tif->tif_rawcc -= tif->tif_scanlinesize;
	return (1);
}
